-----------------------------------------------------------------------------
-- Name:        SheetCam Conversational Drawing
-- Author:      T Parker 
-- Modified by:
-- Created:     06/18/2015


-- Licence:     SheetCam License
-----------------------------------------------------------------------------
mc ={}
evtHandler = wx.wxEvtHandler()

function GetNextID()
    m_id = m_id+1
    return m_id
end
--global var to hold the frame
mainframe = nil
panel = nil
m_id = 0
m_iniName = "FeedsSpeeds"

ID_Calc3_BUT = GetNextID()
ID_Calc2_BUT = GetNextID()
ID_Calc1_BUT = GetNextID()


path1 = sc.GetMyPath().."Cut Charts.bmp"
m_image = wx.wxBitmap(""..path1)

function Setupinputs()
 --Add all the inputs
    local val
    rpm = AddInputControl("Revs Per Min(RPM)",nil) 
    diam = AddInputControl("Tool Diameter", nil) 
    flutes = AddInputControl("Number of Flutes", nil) 
    sfm = AddInputControl("SFM", nil) 
    cl = AddInputControl("Chip Load", nil) 
    spacer1 = AddSpacerControl("",nil)
    spacer2 = AddSpacerControl("",nil)
    CalcFeedrate = AddInputControl("Calc FeedRate", nil) 
    CalcRPM = AddInputControl("Calc RPM", nil) 
    
    end

function OnStart()

if(mcLuaPanelParent == nil)then
    -- create the wxFrame window
    mainframe = wx.wxFrame( wx.NULL,          -- no parent
                        wx.wxID_ANY,          -- whatever for wxWindow ID
                        "SheetCam Feeds & Speeds", -- frame caption
                        wx.wxDefaultPosition, -- place the frame in default position
                        wx.wxDefaultSize,     -- default frame size
                        wx.wxDEFAULT_FRAME_STYLE ) -- use default frame styles

    -- create a panel in the frame
    panel = wx.wxPanel(mainframe, wx.wxID_ANY)

    -- create a simple file menu with an exit
    local fileMenu = wx.wxMenu()
    fileMenu:Append(wx.wxID_EXIT, "E&xit", "Quit the wizard")

    -- create a simple help menu
    local helpMenu = wx.wxMenu()
    helpMenu:Append(wx.wxID_ABOUT, "&About", "About Feeds Speeds")

    -- create a menu bar and append the file and help menus
    local menuBar = wx.wxMenuBar()
    menuBar:Append(fileMenu, "&File")
    menuBar:Append(helpMenu, "&Help")

    -- attach the menu bar into the frame
    mainframe:SetMenuBar(menuBar)

    -- create a simple status bar
    mainframe:CreateStatusBar(1)
    mainframe:SetStatusText("No Error.")

    -- connect the selection event of the exit menu item to an
    -- event handler that closes the window
    mainframe:Connect(wx.wxID_EXIT, 
                      wx.wxEVT_COMMAND_MENU_SELECTED,
                      function (event) 
                          mainframe:Close(true) 
                      end )

    -- connect the selection event of the about menu item
    mainframe:Connect(wx.wxID_ABOUT, wx.wxEVT_COMMAND_MENU_SELECTED,
        function (event)
             wx.wxMessageBox("SheetCam Feeds & Speeds",
                            "About wxLua",
                            wx.wxOK + wx.wxICON_INFORMATION,
                            mainframe)
        end )

else
    panel = mcLuaPanelParent
end

    --Set up the main sizer so we can start adding controls
    local mainSizer = wx.wxBoxSizer(wx.wxVERTICAL)
    local InputsGridSizer  = wx.wxFlexGridSizer( 2, 4, 0, 0 )
    InputsGridSizer:AddGrowableCol(1, 0)
 
    function AddInputControl(name_string, width)
        if(width == nil)then 
            width = 100
        end
        local textCtrlID = GetNextID()
        local staticText = wx.wxStaticText( panel, wx.wxID_ANY, name_string)
        local textCtrl   = wx.wxTextCtrl( panel, textCtrlID, "0", wx.wxDefaultPosition, wx.wxSize(width, -1), wx.wxTE_PROCESS_ENTER ,wx.wxTextValidator(wx.wxFILTER_NUMERIC))
        InputsGridSizer:Add( staticText, 0, wx.wxALIGN_CENTER_VERTICAL+wx.wxALL+wx.wxALIGN_RIGHT, 2)
        InputsGridSizer:Add( textCtrl,   0, wx.wxGROW+wx.wxALIGN_CENTER+wx.wxALL+wx.wxALIGN_LEFT, 2)
        return textCtrl, textCtrlID
    end

    function AddSpacerControl(name_string, width)
        if(width == nil)then 
            width = 100
        end
        local textCtrlID = GetNextID()
        local staticText = wx.wxStaticText( panel, wx.wxID_ANY, name_string)
        InputsGridSizer:Add( staticText, 0, wx.wxALIGN_CENTER_VERTICAL+wx.wxALL+wx.wxALIGN_RIGHT, 2)
        return textCtrl, textCtrlID
    end

    
    -- Add image to the top
    local hbmp = wx.wxBitmap(m_image)
    local TopImage = wx.wxStaticBitmap(panel, wx.wxID_ANY, hbmp )
    
    --Setup the inputs
    Setupinputs()

    -- make the bottom buttons
    local buttonSizer = wx.wxBoxSizer( wx.wxHORIZONTAL )
    if(mcLuaPanelParent == nil)then
    
    local Calc1 = wx.wxButton( panel, ID_Calc1_BUT, "&Calculate FeedRate")
    Calc1:SetBackgroundColour(wx.wxColour(0,255, 128))
    buttonSizer:Add(Calc1, 0, wx.wxALIGN_CENTER+wx.wxALL, 2 )
       
    local Calc3 = wx.wxButton( panel, ID_Calc3_BUT, "C&alculate RPM")
    Calc3:SetBackgroundColour(wx.wxColour(0,255, 255)) 
    buttonSizer:Add(Calc3, 0, wx.wxALIGN_CENTER+wx.wxALL, 2 )
    end
    
    --Set up the sizers
    
    mainSizer:Add(TopImage, 0, wx.wxALIGN_CENTER+wx.wxALL, 2 )
    mainSizer:Add(InputsGridSizer, 0, wx.wxALIGN_CENTER+wx.wxALL, 2 )
    mainSizer:Add(buttonSizer, 0, wx.wxALIGN_CENTER+wx.wxALL, 2 )
   panel:SetSizer( mainSizer )
	
	
   function Calc1()
        local RPM = rpm:GetValue()
        local Flutes = flutes:GetValue()
        local CL = cl:GetValue()
      if (RPM  == "0" or CL == "0" or Flutes == "0") then
        print(" RPM and CL and Flutes are required values")
        else
        Feed = RPM * CL * Flutes
        CalcFeedrate:SetValue(tostring (Feed) , "Calc Feedrate", "00000") 
        CalcFeedrate:SetBackgroundColour( wx.wxColour( 0, 255, 128 ) )
        end    
     end
  
  function Calc3()
        local Diam = diam:GetValue()
        local SFM = sfm:GetValue()
      if (Diam =="0" or SFM == "0") then
        print("Diam and SFM are required values")
        return end
        Speed = (SFM * 3.82)/Diam
        CalcRPM:SetValue(tostring (Speed) , "Calc RPM", "00000") 
        CalcRPM:SetBackgroundColour( wx.wxColour( 0, 255, 255 ) )
    end    
  

   

-- Connect a handler for pressing enter in the textctrls
    panel:Connect(wx.wxID_ANY, wx.wxEVT_COMMAND_TEXT_ENTER,
    function(event)
        -- Send "fake" button press to do calculation.
        -- Button ids have been set to be -1 from textctrl ids.
      --  dialog:ProcessEvent(wx.wxCommandEvent(wx.wxEVT_COMMAND_BUTTON_CLICKED, event:GetId()-1))
    end)

   panel:Connect(ID_Calc1_BUT, wx.wxEVT_COMMAND_BUTTON_CLICKED,
            function(event)            Calc1()
                        end)
         
   panel:Connect(ID_Calc3_BUT, wx.wxEVT_COMMAND_BUTTON_CLICKED,
            function(event)            Calc3()
                        end)
   
   -- show the frame window
     
        panel:Fit()
        mainframe:Fit()
        mainframe:Show(true)
  
   end



function OnFinish()
end

---------------------------------------------------------------------------
function main()
    --add a menu to the main application
    local app = sc.scApp();
    local bitmapPath = sc.GetMyPath()

    local a = _("Scam Feed/Speed") --a bit of fudgery here, these are just here for gettext.
    a = _("Feeds and Speeds") --gettext will add these to the catalog. TNG then reads the catalog on calls to AddMenu and SetMenuPath
 
    app:SetMenuPath("/&Plugins")
    ID_START = app:AddMenu(evtHandler,"Plugins","Feeds and Speeds",_("Feeds and Speeds"),bitmapPath.."",sc.ITEM_NORMAL)
    app:UpdateBars() --regenerate toolbars
    evtHandler:Connect(ID_START, sc.wxEVT_ACTION, OnStart)
end

main()  

